//*****************************************************************************/
// @Module		   Configuration
// 
//
// @Description    This file contains configuration related definition.
//*****************************************************************************/


//XC864BC 	
	
#define	ENABLE_OFF	0	
#define	ENABLE_ON	1	


#define	DIRECTION_SCALE	8	
#define	PULSE_PERIOD	1333	
#define	DUTY_CYCLE_MIN	26	
#define	DUTY_CYCLE_MAX	1265

#define	SPEED_MAX_TARGET	1218	
#define	MOTOR_START_REF	277	
#define	MOTOR_END_REF	555	

#define	SPEED_CONSTANT	144531	
#define	SPEED_TIME_DIV	4	
#define	SPEED_CONSTANT_AV	216796	
#define	SPEED_CONSTANT_AV_FACTOR	3468736	
#define	PP	4	
#define	PP_FACTOR	24	
#define	INDEX_LIMIT	23	

#define	SPEED_RAMPUP_COUNT	180	

#define	INIT_SPEED_KP	0x0080	
#define	INIT_SPEED_KI	0x0040	
#define	PIC_SPEED_YMAX	1305	
#define	PIC_SPEED_YMIN	0	


#define	BEMF_CHECK_FREQ	11250	
#define	END_FREQUENCY	12500	
#define	FREQ_INC	75	
#define	VOLT_INC	358	
#define	START_DUTY_CYC	60	
#define	START_FREQ	1562	
#define	BEMF_AUX_VAL11	0x18	
#define	BEMF_AUX_VAL12	0x24	
#define	BEMF_AUX_VAL21	0x12	
#define	BEMF_AUX_VAL22	0x21	
#define	BEMF_AUX_VAL31	0x06	
#define	BEMF_AUX_VAL32	0x09	
#define	BEMF_CTRL_VAL1	0x20	
#define	BEMF_CTRL_VAL2	0x40	
#define	BEMF_CTRL_VAL3	0x80	

#define	LOW_LIMIT	190	
#define	HIGH_LIMIT	230	
#define	COMPARE_VALUE	206	

#define	DELTA	10	
#define	DELAY	18	
#define	DELAY_TIME_OUT	10000	
#define	DELAY_COMMUT_0	1240	
#define	DELAY_COMMUT_1	5000	
#define	BEMF_CONST_1	1298	
#define	BEMF_CONST_2	1365	
#define	COMMUTATION_ANGLE	0x000FE502	
#define	MOTOR_DIRECTION	0	
#define	CCU6_DEADTIME	0xC		
#define	START_DUTY_CYCLE_MIN	666	


#define	CMDSTART	0x02	
#define	CMDSTOP	0x01	
#define	CMDSET	0x03	
#define	CMDGET	0x04	
#define	CMDSTATUS	0x06


#define	API_NORM_SPEED	3.603604	
#define	API_SPEED_MAX_TARGET	1218	
#define	API_NORM_SPEED_RAMPUP	72072	
#define	API_SPEED_RAMPUP_MIN	2.199465	
#define	API_SPEED_RAMPUP_MAX	30000	
#define	API_NORM_BEMF_FREQ	312	
#define	API_NORM_BEMF_FREQ_INC	200	
#define	API_FREQ_INC_MAX	30000	
#define	API_FREQ_INC_MIN	3.814697E-05	
#define	API_VOLTAGE_INC_MAX	360	
#define	API_VOLTAGE_INC_MIN	0.01099733	
#define	API_NORM_VOLTAGE_INC	360	
#define	API_FREQ	20000


