//****************************************************************************
// @Module        GPIO
// @Filename      IO.C
// @Project       XC864_SCB.dav
//----------------------------------------------------------------------------
// @Controller    Infineon XC864L-1FR
//
// @Compiler      Keil
//
// @Codegenerator 1.1
//
// @Description:  This file contains functions that use the IO module.
//
//----------------------------------------------------------------------------
// @Date          8/15/2009 15:44:58
//
//****************************************************************************

// USER CODE BEGIN (IO_General,1)

// USER CODE END



//****************************************************************************
// @Project Includes
//****************************************************************************

#include "MAIN.H"

// USER CODE BEGIN (IO_General,2)

// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (IO_General,3)

// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

// USER CODE BEGIN (IO_General,4)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (IO_General,5)

// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (IO_General,6)

// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (IO_General,7)

// USER CODE END


//****************************************************************************
// @External Prototypes
//****************************************************************************

// USER CODE BEGIN (IO_General,8)

// USER CODE END


//****************************************************************************
// @Prototypes Of Local Functions
//****************************************************************************

// USER CODE BEGIN (IO_General,9)

// USER CODE END


//****************************************************************************
// @Function      void IO_vInit(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the initialization function of the IO function 
//                library. It is assumed that the SFRs used by this library 
//                are in their reset state. 
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          8/15/2009
//
//****************************************************************************

// USER CODE BEGIN (IO_Init,1)

// USER CODE END

void IO_vInit(void)
{
  // USER CODE BEGIN (IO_Init,2)

  // USER CODE END


  ///  ***********************************************************************
  ///  Note : All peripheral related IO configurations are done in the 
  ///  respective peripheral modules (alternate functions selection)
  ///  
  ///  If no pins are selected DAvE assumes that registers are in default 
  ///  settings
  ///  ***********************************************************************

  ///  -----------------------------------------------------------------------
  ///  Configuration of Port P0:
  ///  -----------------------------------------------------------------------
  ///  P0.0:
  ///  - is used as alternate output for the Output of Capture/Compare 
  ///    channel 1
  ///  - push/pull output is selected
  ///  - pull device is disabled (tristate) 
  ///  P0.1:
  ///  - is used as alternate output for the Output of Capture/Compare 
  ///    channel 1
  ///  - push/pull output is selected
  ///  - pull device is disabled (tristate) 
  ///  P0.2:
  ///  - is used as alternate input for the CCU6 Trap Input
  ///  - pull-up device is assigned
  ///  P0.3:
  ///  - is used as general purpose output
  ///  - push/pull output is selected
  ///  - the pin status is low level
  ///  - pull device is disabled (tristate) 
  ///  P0.4:
  ///  - is used as alternate output for the Output of Capture/Compare 
  ///    channel 2
  ///  - push/pull output is selected
  ///  - pull device is disabled (tristate) 
  ///  P0.5:
  ///  - is used as alternate output for the Output of Capture/Compare 
  ///    channel 2
  ///  - push/pull output is selected
  ///  - pull device is disabled (tristate) 


  SFR_PAGE(_pp1, noSST);         // switch to page 1
  P0_PUDSEL     =  0xFF;         // load pullup/pulldown select register
  P0_PUDEN      =  0xC4;         // load pullup/pulldown enable register

  SFR_PAGE(_pp0, noSST);         // switch to page 0
  P0_DIR        =  0x08;         // load direction register

  ///  -----------------------------------------------------------------------
  ///  Configuration of Port P1:
  ///  -----------------------------------------------------------------------
  ///  P1.0:
  ///  - is used as alternate input for the UART Receive Input
  ///  - pull device is disabled (tristate) 
  ///  P1.1:
  ///  - is used as alternate output for the UART Transmit Output
  ///  - open drain output is selected
  ///  - pull-up device is assigned

  SFR_PAGE(_pp3, noSST);         // switch to page 3
  P1_OD         =  0x02;         // load open-drain register

  SFR_PAGE(_pp1, noSST);         // switch to page 1
  P1_PUDSEL     =  0xFF;         // load pullup/pulldown select register
  P1_PUDEN      =  0xFE;         // load pullup/pulldown enable register

  ///  -----------------------------------------------------------------------
  ///  Configuration of Port P2:
  ///  -----------------------------------------------------------------------
  ///  P2.0:
  ///  - is used as alternate input for the Analog Input 0
  ///  - pull device is disabled (tristate) 
  ///  P2.1:
  ///  - is used as alternate input for the Analog Input 1
  ///  - pull device is disabled (tristate) 
  ///  P2.2:
  ///  - is used as alternate input for the Analog Input 2
  ///  - pull device is disabled (tristate) 
  ///  P2.7:
  ///  - is used as alternate input for the Analog Input 7
  ///  - pull device is disabled (tristate) 


  ///  -----------------------------------------------------------------------
  ///  Configuration of Port P3:
  ///  -----------------------------------------------------------------------
  ///  P3.0:
  ///  - is used as alternate output for the Output of Capture/Compare 
  ///    channel 0
  ///  - push/pull output is selected
  ///  - pull device is disabled (tristate) 
  ///  P3.1:
  ///  - is used as alternate output for the Output of Capture/Compare 
  ///    channel 0
  ///  - push/pull output is selected
  ///  - pull device is disabled (tristate) 


  P3_PUDSEL     =  0xBF;         // load pullup/pulldown select register

  SFR_PAGE(_pp0, noSST);         // switch to page 0

  // USER CODE BEGIN (IO_Init,3)

  // USER CODE END

} //  End of function IO_vInit




// USER CODE BEGIN (IO_General,10)

// USER CODE END

