//****************************************************************************
// @Module        Project Settings
// @Filename      MAIN.C
// @Project       XC864_SCB.dav
//----------------------------------------------------------------------------
// @Controller    Infineon XC864L-1FR
//
// @Compiler      Keil
//
// @Codegenerator 1.1
//
// @Description   This file contains the Project initialization function.
//
//----------------------------------------------------------------------------
// @Date          8/15/2009 15:44:58
//
//****************************************************************************

// USER CODE BEGIN (MAIN_General,1)

// USER CODE END



//****************************************************************************
// @Project Includes
//****************************************************************************

#include "MAIN.H"

// USER CODE BEGIN (MAIN_General,2)

// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (MAIN_General,3)

// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

// USER CODE BEGIN (MAIN_General,4)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (MAIN_General,5)

// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (MAIN_General,6)

// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (MAIN_General,7)

 bdata 	unsigned char 	Status_word;
		sbit			gb_overcurrent 	= Status_word^5;
		sbit 			gb_hs_error    	= Status_word^4;
		sbit 			gb_ctrap       	= Status_word^3;
		sbit 			gb_time_out 	= Status_word^2;
		sbit 			gb_On        	= Status_word^1;
		sbit 			gb_Off       	= Status_word^0;

idata	int   		    Rampup_Counter 		_at_(0x008E);
data	unsigned int	g_direction 		_at_(0x2E);	

data	unsigned int 	g_speed_start_ref 	_at_(0x0028);	
idata	unsigned int  	g_speed_end_ref  	_at_(0x008C); 	 		
idata 	unsigned int   	speed_kp  			_at_(0x0092);
idata	unsigned int   	speed_ki  			_at_(0x0094);
idata	int 			g_speed_CC60 		_at_(0x90);

idata 	unsigned int 	g_start_freq 		_at_(0x0080);
idata  	int 			g_freq_increment 	_at_(0x0082);	
idata  	int 			g_volt_increment 	_at_(0x0084);
idata	unsigned int 	g_start_duty_c 		_at_(0x0086);

idata 	unsigned int 	g_bemf_check_freq 	_at_(0x0088);					   
idata 	unsigned int  	g_bemf_end_freq 	_at_(0x008A);

int API_Ref=0;
// USER CODE END


//****************************************************************************
// @External Prototypes
//****************************************************************************


// USER CODE BEGIN (MAIN_General,8)

 extern void MotorControl_vInit( void );
// USER CODE END


//****************************************************************************
// @Prototypes Of Local Functions
//****************************************************************************

// USER CODE BEGIN (MAIN_General,9)

// USER CODE END


//****************************************************************************
// @Function      void MAIN_vInit(void) 
//
//----------------------------------------------------------------------------
// @Description   This function initializes the microcontroller. It is 
//                assumed that the SFRs are in their reset state.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          8/15/2009
//
//****************************************************************************

// USER CODE BEGIN (MAIN_Init,1)

// USER CODE END

void MAIN_vInit(void)
{
  // USER CODE BEGIN (MAIN_Init,2)

  // USER CODE END

  ///  -----------------------------------------------------------------------
  ///  Configuration of the System Clock:
  ///  -----------------------------------------------------------------------
  ///  - On Chip Osc is Selected
  ///  - PLL Mode, NDIV = 2
  ///  - input frequency is 10 MHz



  ///  *********************************************************************************
  ///  Note : All peripheral related IO configurations are done in the 
  ///  respective peripheral modules (alternate functions selection)
  ///  *********************************************************************************


  ///  Initialization of module 'GPIO'
  IO_vInit();

  ///  Initialization of module 'UART (Serial Interface)'
  UART_vInit();

  ///  Initialization of module 'Timer 2'
  T2_vInit();

  ///  Initialization of module 'Analog / Digital Converter (ADC)'
  ADC_vInit();

  ///  Initialization of module 'Capture / Compare Unit 6 (CCU6)'
  CC6_vInit();

  //   Interrupt Priority

  IP            =  0x10;         // load Interrupt Priority Register
  IPH           =  0x00;         // load Interrupt Priority High Register
  IP1           =  0x00;         // load Interrupt Priority 1 Register
  IPH1          =  0x00;         // load Interrupt Priority 1 High Register


  // USER CODE BEGIN (MAIN_Init,3)

  // USER CODE END

  //   globally enable interrupts
  EA            =  1;           

} //  End of function MAIN_vInit


//****************************************************************************
// @Function      void main(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the main function.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          8/15/2009
//
//****************************************************************************

// USER CODE BEGIN (MAIN_Main,1)

// USER CODE END

void main(void)
{
  // USER CODE BEGIN (MAIN_Main,2)

  // USER CODE END

  MAIN_vInit();

  // USER CODE BEGIN (MAIN_Main,3)
	MotorControl_vInit();

	API_Ref=0;
  // USER CODE END

  while(1)
  {

  // USER CODE BEGIN (MAIN_Main,4)

  // USER CODE END

  }

} //  End of function main


// USER CODE BEGIN (MAIN_General,10)

// USER CODE END

