//////////////////////////////////////////////////////////////////////
//********************************************************************
//**************		SCHEDULER UART Function		******************
//********************************************************************
//////////////////////////////////////////////////////////////////////

//****************************************************************************
// @Project Includes
//****************************************************************************
#include "MAIN.H"
#include "CONFIG.H"
//****************************************************************************
// @Macros
//****************************************************************************


//****************************************************************************
// @Defines
//****************************************************************************
  
  

//****************************************************************************
// @Typedefs
//****************************************************************************


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

extern	idata	int  			g_speed_CC60;
extern	data	unsigned char 	Status_word; 

extern	idata	unsigned int  	g_speed_end_ref;
extern	idata	unsigned int  	g_speed_ref ;
extern	data  	unsigned int 	g_pi_controller_out;
extern	idata	int  			g_duty_cyc;
extern	bit						gb_On;
extern	bit						gb_ctrap;
extern  data  unsigned char		Tx_Count;
extern  data  unsigned char		Tx_Max;
//****************************************************************************
// @Global Variables
//****************************************************************************
data   unsigned char data 	*adr;
unsigned char	UART_Rx[4];
xdata   unsigned char   UART_Tx2[8];
//****************************************************************************
// @External Prototypes
//****************************************************************************
extern void MotorStart(void);
extern void MotorStop(void);

 //****************************************************************************
// @Prototypes Of Local Functions
//****************************************************************************
void Scheduler(void);
void Status(void);
void SendUARTMsg(char UARTData);
//****************************************************************************

void Scheduler(void)
{
 
	switch(UART_Rx[0]) 
	{
		case CMDSTOP:
   				MotorStop();
				break;

	   case CMDSTART:
			 	MotorStart();
				break;
	
		case CMDSET:	
				adr = (unsigned char*) UART_Rx[1];
				*adr++ = UART_Rx[2];  //lower byte
				*adr  = UART_Rx[3];
				break;

		case CMDGET:
		  	adr = (unsigned char data*) UART_Rx[1];
			UART_Tx2[0]=(UART_Rx[1]);
			UART_Tx2[1]=(*(unsigned char data *) (adr));
			UART_Tx2[2]=(*(unsigned char data *) (adr+1));
			Tx_Count=0;
			Tx_Max =3;
			REN = 0;
			SBUF =CMDGET;
			break;
				

		case CMDSTATUS:
				Status();
				break;

		default:
			break;	

	}


}


void Status(void)
{
   UART_Tx2[0]=(Status_word);
   UART_Tx2[1]=(g_speed_CC60>>8);
   UART_Tx2[2]=(g_speed_CC60);
   Tx_Count=0;
   Tx_Max =3;
   REN = 0;
   SBUF =0x06;

}
