//****************************************************************************
// @Module        Timer 2
// @Filename      T2.C
// @Project       XC864_SCB.dav
//----------------------------------------------------------------------------
// @Controller    Infineon XC864L-1FR
//
// @Compiler      Keil
//
// @Codegenerator 1.1
//
// @Description:  This file contains functions that use the T2 module.
//
//----------------------------------------------------------------------------
// @Date          8/15/2009 15:44:59
//
//****************************************************************************

// USER CODE BEGIN (T2_General,1)

// USER CODE END



//****************************************************************************
// @Project Includes
//****************************************************************************

#include "MAIN.H"

// USER CODE BEGIN (T2_General,2)

	#include "CONFIG.H"
// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (T2_General,3)

// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

// USER CODE BEGIN (T2_General,4)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (T2_General,5)

// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (T2_General,6)

 extern bit bituartRI;
// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (T2_General,7)

// USER CODE END


//****************************************************************************
// @External Prototypes
//****************************************************************************

// USER CODE BEGIN (T2_General,8)

 extern void Scheduler(void);
extern void Read_Speed(void);
// USER CODE END


//****************************************************************************
// @Prototypes Of Local Functions
//****************************************************************************

// USER CODE BEGIN (T2_General,9)

// USER CODE END


//****************************************************************************
// @Function      void T2_vInit(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the initialization function of the Timer 2 function 
//                library. It is assumed that the SFRs used by this library 
//                are in their reset state. 
//                
//                The following SFRs and SFR fields will be initialized:
//                T2_RC2H/RC2L     - reload/capture timer 2 register
//                ET2           - timer 2 interrupt enable
//                T2_T2MOD         - timer 2 mode register
//                CP/RL2        - Capture/Reload select
//                EXEN2         - External enable control
//                TR2           - Timer2 run control
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          8/15/2009
//
//****************************************************************************

// USER CODE BEGIN (T2_Init,1)

// USER CODE END

void T2_vInit(void)
{
  // USER CODE BEGIN (T2_Init,2)

  // USER CODE END

  //   -----------------------------------------------------------------------
  //   Operating Mode
  //   -----------------------------------------------------------------------

  ///  16-bit timer function with automatic reload when timer 2 overflows
  ///  the timer 2 resolution is 0.45 usec
  ///  the timer 2 overflow is 9216.000 usec
  ///  timer 2 interrupt: enabled
  ///  timer 2 will be started

  //   -----------------------------------------------------------------------
  //   Register Initialization
  //   -----------------------------------------------------------------------

  T2_RC2L       =  0x00;         // load timer 2 reload/capture register,   
                                 // low byte
  T2_RC2H       =  0xB0;         // load timer 2 reload/capture register,   
                                 // high byte
  T2_T2MOD      =  0x00;         // load timer 2 mode register

  ET2 = 1;                       // Enable interrupt

  // USER CODE BEGIN (T2_Init,3)

  // USER CODE END

  TR2 = 1; //   start timer

} //  End of function T2_vInit


//****************************************************************************
// @Function      void T2_viTmr(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the service routine for the Timer 2 interrupt. 
//                Depending on the selected operating mode it is called when 
//                TF2 is set by an overflow or underflow of the timer 2 
//                register or when EXF2 is set by a negative transition on 
//                T2EX.
//                Please note that you have to add application specific code 
//                to this function.
//
//----------------------------------------------------------------------------
// @Returnvalue   none
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          8/15/2009
//
//****************************************************************************

// USER CODE BEGIN (T2_IsrTmr,1)

// USER CODE END

void T2_viTmr(void) interrupt T2INT
{
  // USER CODE BEGIN (T2_IsrTmr,2)

  // USER CODE END

  SFR_PAGE(_su0, SST0);          // switch to page 0
  if (TF2)
  {
    //   a timer 2 overflow has occured
    TF2 = 0;
    // USER CODE BEGIN (T2_IsrTmr,3)
	if(bituartRI)
	{	 
		bituartRI=0;
		Scheduler(); 
	
	}
	SFR_PAGE(_ad6, noSST);
	ADC_CRCR1 = 0x80;								   //	write channel information to be converted
	ADC_CRMR1 |= 0x40; 								   //  generate load event	
    Read_Speed();

    // USER CODE END

  }

  // USER CODE BEGIN (T2_IsrTmr,5)

  // USER CODE END

  SFR_PAGE(_su0, RST0);          // restore the old page
} //  End of function T2_viTmr


// USER CODE BEGIN (T2_General,10)

// USER CODE END

