//****************************************************************************
// @Module        UART (Serial Interface)
// @Filename      UART.C
// @Project       XC864_SCB.dav
//----------------------------------------------------------------------------
// @Controller    Infineon XC864L-1FR
//
// @Compiler      Keil
//
// @Codegenerator 1.1
//
// @Description:  This file contains functions that use the UART module.
//
//----------------------------------------------------------------------------
// @Date          8/15/2009 15:44:58
//
//****************************************************************************

// USER CODE BEGIN (UART_General,1)

// USER CODE END



//****************************************************************************
// @Project Includes
//****************************************************************************

#include "MAIN.H"

// USER CODE BEGIN (UART_General,2)

// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (UART_General,3)

// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

// USER CODE BEGIN (UART_General,4)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (UART_General,5)

// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (UART_General,6)

  extern unsigned char UART_Rx[4];
 extern xdata   unsigned char   UART_Tx2[8];
 extern xdata	unsigned char	UART_Tx0[5];
 extern xdata	unsigned char	UART_Tx1[6];
// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (UART_General,7)
  unsigned char RI_Count;
  bit bituartRI;
  data  unsigned char	Tx_Count;
  data  unsigned char	Tx_Max;
// USER CODE END


//****************************************************************************
// @External Prototypes
//****************************************************************************

// USER CODE BEGIN (UART_General,8)
  extern void Scheduler(void);
// USER CODE END


//****************************************************************************
// @Prototypes Of Local Functions
//****************************************************************************

// USER CODE BEGIN (UART_General,9)

// USER CODE END


//****************************************************************************
// @Function      void UART_vInit(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the initialization function of the UART function 
//                library. It is assumed that the SFRs used by this library 
//                are in their reset state. 
//                
//                The following SFR fields will be initialized:
//                - register SCON
//                - bits SMOD and ES
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          8/15/2009
//
//****************************************************************************

// USER CODE BEGIN (UART_Init,1)

// USER CODE END

void UART_vInit(void)
{
  // USER CODE BEGIN (UART_Init,2)

  // USER CODE END

  ///  -----------------------------------------------------------------------
  ///  UART settings
  ///  -----------------------------------------------------------------------
  ///  Pin TXD_0 (P1.1) is selected for transmission
  ///  Pin RXD_0 (P1.0) is selected for reception
  ///  Receiver enabled
  ///  Mode 1: 8-bit data, 1 start bit, 1 stop bit, variable baud rate
  ///  BRG is selected for baudrate generation

  SFR_PAGE(_pp2, noSST);         // switch to page 2 without saving
  P1_ALTSEL0   &= ~(ubyte)0x02;  // configure alternate function register 0
  P1_ALTSEL1   |=  (ubyte)0x02;  // configure alternate function register 1
  SFR_PAGE(_pp0, noSST);         // switch to page 0 without saving
  P1_DIR       |=  (ubyte)0x02;  // set output direction




  MODPISEL     &= ~(ubyte)0x01;  // configure peripheral input select register
  BCON          =  0x00;         // reset baudrate timer/reload register
  SCON          =  0x50;         // load serial channel control register

  ///  -----------------------------------------------------------------------
  ///  Baudrate generator settings
  ///  -----------------------------------------------------------------------
  ///  input clock = fPCLK
  ///  Fractional divider is enabled
  ///  baudrate = 256.0764 kbaud

  FDSTEP        =  0x76;         // load fractional divider reload register
  BG            =  0x02;         // load baudrate timer/reload register
  FDCON        |=  0x01;         // load Fractional Divider control register
  BCON         |=  0x01;         // load baud rate control register


  // USER CODE BEGIN (UART_Init,3)

  // USER CODE END

  ///  UART interrupt enabled
  ES = 1;

} //  End of function UART_vInit


//****************************************************************************
// @Function      void UART_viIsr(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the service routine for the UART interrupt. It is 
//                called after each transmission (flag TI set) or reception 
//                (flag RI set) of a data unit.
//                Please note that you have to add application specific code 
//                to this function.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          8/15/2009
//
//****************************************************************************

// USER CODE BEGIN (UART_Isr,1)

// USER CODE END

void UART_viIsr(void) interrupt UARTINT
{
    // USER CODE BEGIN (UART_Isr,2)

    // USER CODE END
  SFR_PAGE(_su0, SST1);          // switch to page 0
  if (TI)
  {
    // USER CODE BEGIN (UART_Isr,3)

       TI = 0;
			if(Tx_Count < Tx_Max)
			{
				SBUF =UART_Tx2[Tx_Count];
				Tx_Count++;
			}
			else
				REN=1;

		
    // USER CODE END
  }
  if (RI)
  {
    // USER CODE BEGIN (UART_Isr,4)

       RI = 0;
		if(bituartRI==0)
	   {
	   UART_Rx[RI_Count]=SBUF;
	   RI_Count++;
	    if(RI_Count>3)
	   {
			RI_Count=0;
			bituartRI=1;
	
		}
		}

    // USER CODE END
  }
    // USER CODE BEGIN (UART_Isr,5)

    // USER CODE END

  SFR_PAGE(_su0, RST1);          // restore the old page
} //  End of function UART_viIsr
// USER CODE BEGIN (UART_General,10)

// USER CODE END

